import sys, json, subprocess, random, re, os

hidden_train_fpath = sys.argv[1]
test_fpath = sys.argv[2]
result_fpath = sys.argv[3]
hidden_train_flag = True if sys.argv[4] == 'True' else False

print('Parsed args: {}\t{}\t{}\t{}'.format(hidden_train_fpath, test_fpath, result_fpath, hidden_train_flag))

'''
Recorded times:
    >>> trg=(10.08, 19.55, 9.8, 50)
    >>> arg=(20.14, 19.35, 23.4, 50)
    >>> coref = (7.40, 17.28, 9.8, 50)

==================
New estimated times:
trg = 9.8/50 * 16
arg = 23.4/50 * 18
coref = 9.8/50 * 8

trg + arg + coref = 13.2

with ? hidden documents, the retraining time will be: 15.24 * 150% ~ 19.7 hours

-> 4.3 hours left for prediction is very safe and ok now
'''

combine_hidden_data_cmd = ['python', 'combine_hidden_data.py']

prepare_trg_data_cmd = ['python', 'util.py', '1']

train_trg_cmd = ['python', 'train.py', '--model_name', 'trg', '--xlmr_model_name', 'xlm-roberta-large', '--batch_size', '16', '--xlmr_learning_rate', '1e-5', '--event_hidden_num', '450', '--accumulate_step', '4', '--max_epoch', '16', '--p1_data_weight', '0.1', '--learning_rate', '1e-4', '--docker_run']

prepare_arg_data_cmd = ['python', 'util.py', '2']

train_arg_cmd = ['python', 'train.py', '--model_name', 'arg', '--xlmr_model_name', 'xlm-roberta-large', '--batch_size', '16', '--xlmr_learning_rate', '1e-5', '--learning_rate', '1e-4', '--max_epoch', '18', '--p1_data_weight', '0.4', '--event_hidden_num', '450', '--role_hidden_num', '350', '--docker_run']

prepare_coref_data_cmd = ['python', 'util.py', '5']

train_coref_cmd = ['python', 'train.py', '--model_name', 'coref', '--xlmr_model_name', 'xlm-roberta-large', '--batch_size', '16', '--xlmr_learning_rate', '1e-5', '--accumulate_step', '4', '--max_epoch', '8', '--event_hidden_num', '500', '--p1_data_weight', '0.2', '--learning_rate', '1e-4', '--docker_run']

if hidden_train_flag:
    subprocess.run(combine_hidden_data_cmd)
    subprocess.run(prepare_trg_data_cmd)
    subprocess.run(train_trg_cmd)
    subprocess.run(prepare_arg_data_cmd)
    subprocess.run(train_arg_cmd)
    subprocess.run(prepare_coref_data_cmd)
    subprocess.run(train_coref_cmd)

predict_cmd = ['python', 'train.py', '--model_name', 'pipeline', '--docker_run']

subprocess.run(predict_cmd)
