# Copyright (C) 2007 - 2021 The MITRE Corporation. See the toplevel
# file LICENSE.txt for license terms.

from .PyCompat import _unicodestring

# The error class

class MATError(Exception):
    def __init__(self, phase, errstr, show_tb = False, file = None):
        self.phase = phase
        self.errstr = errstr
        self.tb_str = ""
        self.file = file
        self.prefix = "for phase " + self.phase
        if self.file:
            self.prefix += ", file " + self.file
        if show_tb:
            import traceback, sys
            self.tb_str = "".join(traceback.format_tb(sys.exc_info()[2]))
    def __str__(self):
        return self.prefix + ": " + self.errstr + "\n" + self.tb_str

    def __unicode__(self):
        return _unicodestring(self.__str__())
        

class TaggerConfigurationError(Exception):
    pass

class TaggingError(Exception):
    pass

# I put this here, instead of in PluginMgr, so that
# Document.py can grab it without a circular reference.

class PluginError(Exception):
    pass
